### Method

# Gio File append_to

#### Declaration

    GFileOutputStream*
    g_file_append_to (
      GFile* file,
      GFileCreateFlags flags,
      GCancellable* cancellable,
      GError** error
    )

#### Description

Gets an output stream for appending data to the file. If the file doesn’t already exist it is created.

By default files created are generally readable by everyone, but if you pass `G_FILE_CREATE_PRIVATE` in `flags` the file will be made readable only to the current user, to the level that is supported on the target filesystem.

If `cancellable` is not `NULL`, then the operation can be cancelled by triggering the cancellable object from another thread. If the operation was cancelled, the error `G_IO_ERROR_CANCELLED` will be returned.

Some file systems don’t allow all file names, and may return an `G_IO_ERROR_INVALID_FILENAME` error. If the file is a directory the `G_IO_ERROR_IS_DIRECTORY` error will be returned. Other errors are possible too, and depend on what kind of filesystem the file is on.

#### Parameters

`flags`

  Type: `GFileCreateFlags`

  A set of `GFileCreateFlags`.

`cancellable`

  Type: `GCancellable`

  Optional `GCancellable` object, `NULL` to ignore.

  The argument can be `NULL`.
  The data is owned by the caller of the method.

`error`

  Type: `GError **`

  The return location for a recoverable error.

  The argument can be `NULL`.
  If the return location is not `NULL`, then you must initialize it to a `NULL` `GError*`.
  The argument will be left initialized to `NULL` by the method if there are no errors.
  In case of error, the argument will be set to a newly allocated `GError`; the caller will take ownership of the data, and be responsible for freeing it.

#### Return value

Type: `GFileOutputStream`

A `GFileOutputStream`, or `NULL` on error. Free the returned object with g_object_unref().

The caller of the method takes ownership of the returned data, and is responsible for freeing it.